Cleaned up description of handbrake cli vars.
[rip_dvd/.git] / rip_dvd
1 #!/bin/bash
2 #
3 # Author: Alan J. Pippin (apippin@pippins.net)
4 # Date: 05/17/2009
5 #
6   REV=2.2
7 #
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing 
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
13 # may be used for.
14 #
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
17 #
18 # Package Dependencies (apt-get install these for example):
19 # lsdvd dvdauthor gddrescue dvdbackup tovid mencoder mplayer genisoimage libdvdcss2
20 #
21 # Specific Executable (program) Dependencies (must be found in $PATH):
22 # volname makexml lsdvd dvdauthor gddrescue dvdbackup mencoder mplayer mkisofs HandBrakeCLI
23 #
24 # Optional Dependencies:
25 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
26 #
27
28 ##############################################################################################
29 # Global Variables
30 ##############################################################################################
31 typeset cmd="$0 $*"
32 typeset dvdname=""
33 typeset debug=""
34 typeset dest=""
35 typeset isofile=""
36 typeset vobfile=""
37 typeset dvdpath=""
38 typeset aspect=""
39 typeset SCALE=""
40 typeset CROP=""
41 typeset profile="xvidhq"
42 typeset extension=""
43 typeset mailto=""
44 typeset encoder=""
45 typeset default_alang="en"
46 typeset track=""
47 typeset drc="0.0"
48 typeset -i default_aid=128
49 typeset -i aid_override=-1
50 typeset -i force_onepass_mode=0
51 typeset -i eject_disk=1
52 typeset -i keep_isofile=0
53 typeset -i keep_vobfile=0
54 typeset -i keep_dvdfolder=0
55 typeset -i keep_intermediate_files=0
56 typeset -i make_final_dest_vob=0
57 typeset -i make_final_dest_iso=0
58 typeset -i make_final_dest_folder=0
59 typeset -i make_final_dest_comp=0
60 typeset -i errors=0
61 typeset -i show_usage=0
62 typeset -i mirror_mode=0
63 typeset -i target_bitrate=2000
64 typeset -i target_size=0
65 typeset -i audio_2ch=0
66 typeset -i audio_6ch=1
67 typeset -i invalid_feature_title=0
68 typeset -i feature_title_override=0
69 typeset -i mplayer_dumpstream_incompatibility=0
70 typeset -i custom_bitrate=0
71 typeset -i custom_audio_2ch=0
72 typeset -i custom_audio_6ch=0
73
74 ##############################################################################
75 # Local Machine Settings:
76 # Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
77 # and the local conf file created by each local machine (rip_dvd.conf)
78 # Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
79 # This will allow you to override all the default values to meet your needs
80 # in a way that won't get clobbered when you pull updates from my GIT repo.
81 ##############################################################################
82 config="${0%/*}/rip_dvd.conf"
83
84 # The config file will be searched for in the following location order:
85 found_config=0
86
87 # 1) /path/to/rip_dvd/script/rip_dvd.conf.dist
88 [ -e "${config}.dist" ] && found_config=1 && . "${config}.dist"
89
90 # 2) /path/to/rip_dvd/script/rip_dvd.conf
91 [ -e "${config}" ] && found_config=1 && . "${config}"
92
93 # 3) /etc/rip_dvd.conf
94 [ -e "/etc/rip_dvd.conf" ] && found_config=1 && . "/etc/rip_dvd.conf"
95
96 # 4) $PWD/rip_dvd.conf
97 [ -e "$PWD/rip_dvd.conf" ] && found_config=1 && . "$PWD/rip_dvd.conf"
98
99 # Check to make sure we found the config file
100 if [ $found_config -eq 0 ]; then
101   echo "-E- Unable to find the rip_dvd.conf file: $config"
102   exit 1
103 fi
104
105 ##############################################################################################
106 # Command line processing
107 ##############################################################################################
108 while (($#)) && getopts 162wmvifkzx:ht:n:d:b:s:t:a:p:e:j:l:r: opt "$@"
109 do
110     case $opt in
111         (n)     dvdname=$OPTARG;;
112         (d)     dest=$OPTARG;;
113         (b)     target_bitrate=$OPTARG; custom_bitrate=1;;
114         (s)     target_size=$OPTARG;;
115         (2)     audio_2ch=1; custom_audio_2ch=1;;
116         (6)     audio_6ch=1; custom_audio_6ch=1;;
117         (1)     force_onepass_mode=1;;
118         (v)     make_final_dest_vob=1;;
119         (i)     make_final_dest_iso=1;;
120         (f)     make_final_dest_folder=1;; 
121         (z)     make_final_dest_comp=1;;
122         (e)     encoder=$OPTARG;;
123         (m)     mirror_mode=1;;
124         (k)     keep_intermediate_files=1;;
125         (t)     feature_title_override=$OPTARG;;
126         (a)     aspect=$OPTARG;;
127         (p)     profile=$OPTARG;;
128         (x)     extension=$OPTARG;;
129         (j)     eject_disk=$OPTARG;;
130         (l)     aid_override=$OPTARG;;
131         (r)     drc=$OPTARG;;
132         (w)     set -x;;
133         (h)     show_usage=1;;
134         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
135         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
136     esac
137 done
138
139 shift $((OPTIND-1))
140
141 function usage() {
142     echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
143     echo >&2 "Revision $REV"
144     echo >&2 "Options:"
145     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
146     echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
147     echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
148     echo >&2 "                 2) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
149     echo >&2 "                 3) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
150     echo >&2 "                 4) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
151     echo >&2 "                 5) If dvdname is a full path to a VOB file, it will be ripped as a DVD instead of $dev"
152     echo >&2 "   -p <profile>  Specify which encoding profile to use in -w mode as shown below:"
153     echo >&2 "                 Mencoder and Handbrake Encoder Profiles:"
154     echo >&2 "                 - xvidvhq = AVI, very high quality encoding, Xvid codec, 2 pass encoding"
155     echo >&2 "                 - xvidhq = AVI, high quality encoding, Xvid codec, 2 pass encoding (default)"
156     echo >&2 "                 - xvid = AVI, fast encoding, Xvid codec, 2 pass encoding"
157     echo >&2 "                 - iphone = MP4, x264 codec, 2 pass encoding, forced 480:320 scaling"
158     echo >&2 "                 - ipod = MP4, x264 codec, 2 pass encoding, forced 320:240 scaling"
159     echo >&2 "                 Handbrake Only Encoder Profiles:"
160     echo >&2 "                 - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding"
161     echo >&2 "                 - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding"
162     echo >&2 "                 - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding"
163     echo >&2 "                 - hb_<profile> = Any predefined HandBrake profile (run HandBrakeCLI -z and replace spaces with underscores) "
164     echo >&2 "   -x <ext>      Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
165     echo >&2 "                 If you run multiple instances of this script ripping the same DVD, you need to specify this option."
166     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
167     echo >&2 "                 The default operation is non-mirror mode where only the main"
168     echo >&2 "                 feature title will be ripped."
169     echo >&2 "   -v            Make the final image a DVD VOB file"
170     echo >&2 "   -i            Make the final image a DVD ISO file"
171     echo >&2 "   -f            Make the final image a DVD folder"
172     echo >&2 "   -z            Make the final image a compressed file based on your profile selection and encoder"
173     echo >&2 "   -e <encoder>  Specify the encoder to use to make the compressed file (valid encoders=mencoder|handbrake) (default=handbrake if found)"
174     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options with xvid profiles"
175     echo >&2 "   -s <size>     Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
176     echo >&2 "   -b <bitrate>  Set the bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"    
177     echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -z mode)"
178     echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
179     echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
180     echo >&2 "   -j <n>        Eject the disk:"
181     echo >&2 "                 - 0 = do not eject the disk"
182     echo >&2 "                 - 1 = eject after the entire script is done (default)"
183     echo >&2 "                 - 2 = eject after the disk is no longer needed (prior to starting the encode process)"
184     echo >&2 "                 The last option will allow you to start ripping another disk while the encoding process is running on a previous"
185     echo >&2 "   -1            Force 1-pass encoding mode across all profiles"
186     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
187     echo >&2 "   -6            Use 6 channel AC3 audio encoding when making a compressed file (default)"
188     echo >&2 "   -r <x.x>      Apply extra dynamic range compression to the audio, making soft sounds louder. "
189     echo >&2 "                 Range is 1.0 to 4.0 with 1.5 - 2.5 being a useful range (HandBrake Only) (default value is 0.0)"
190     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
191     echo >&2 "                 In -z mode, run with this option to keep the original .VOB file"
192     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
193     echo >&2 "   -l <aid>      Specify the audio AID language ID to rip from the source DVD"
194     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
195     echo >&2 "   -w            Set the sh Execute/Verbose flag (causes every command to be echoed)"
196     echo >&2 ""
197     exit 2
198 }
199
200 if (($errors)) || (($show_usage))
201 then
202   usage
203 fi
204
205 # Sanity Check - Command Line Options 
206 if [ "$dest" == "" ]; then
207   echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
208   usage
209 fi
210
211 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
212    [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
213     # Make our default dest type a compressed movie if the user didn't ask for anything else to be done
214     make_final_dest_comp=1
215 fi
216
217 if ([ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
218   echo "-E- You can't specify a target_size, or aspect in non compressed file mode. You must specify '-z' when using '-b' or '-s' or '-a'" | tee -a $logfile
219   usage
220 fi
221
222 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
223   echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-z'" | tee -a $logfile
224   usage
225 fi
226
227 if [ $mirror_mode -eq 1 ]; then
228   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
229      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
230     echo "-E- You can't specify '-v' or '-i' or '-f' or '-z' when operating in mirror mode with '-m'" | tee -a $logfile
231     usage
232   fi
233 fi
234
235 # Make handbrake the default encoder if not specified and we can find it
236 if [ -z "$encoder" ]; then
237   encoder="mencoder"; # If we can't find handbrake, set mencoder as the default
238   [[ -x `which $handbrake_xvid` ]] && [[ "$profile" =~ "xvid" ]] && encoder="handbrake";
239   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "mp4" ]] && encoder="handbrake";
240   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "ip" ]] && encoder="handbrake";
241   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "hb" ]] && encoder="handbrake";
242 fi
243
244 # Sanity check the profile selection
245 if [[ "$encoder" == "mencoder" ]]; then
246   [[ "$profile" =~ "mp4" ]] && echo "-E- invalid encoder $encoder selected for mp4 profile: $profile" && exit
247 fi
248
249 if [[ "$encoder" != "mencoder" ]] && [[ "$encoder" != "handbrake" ]]; then
250   echo "-E- Invalid encoder specified: $encoder"
251   exit 1
252 fi
253
254 # If the aspect ratio option was specified, set the scale variable appropriately for mencoder
255 if [ "$aspect" != "" ]; then
256   echo "$aspect" | grep -q "x"
257   if [ $? == 0 ]; then
258     echo "-E- You must specify the aspect option with a value whose format is W:H"
259     exit 1
260   fi
261   echo "$aspect" | grep -q ":"
262   if [ $? != 0 ]; then
263     [ "$encoder" == "mencoder" ] && SCALE=",scale -zoom -sws 9 -xy $aspect"
264     [ "$encoder" == "handbrake" ] && SCALE="-w $aspect"
265   else
266     [ "$encoder" == "mencoder" ] && SCALE=",scale=$aspect"
267     if [ "$encoder" == "handbrake" ]; then
268        WIDTH=`echo "$aspect" | awk -F ':' '{ print $1; }'`
269        HEIGHT=`echo "$aspect" | awk -F ':' '{ print $2; }'`
270        SCALE="-w $WIDTH -l $HEIGHT"
271     fi
272   fi
273 fi
274
275 # Sanity Check - Key executables
276 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
277 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
278 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
279 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
280 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
281 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
282 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
283 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
284 [[ -n "$handbrake_xvid" ]] && [[ ! -x `which $handbrake_xvid` ]] && echo "-E- missing handbrake xvid encoder, set in rip_dvd.conf to: $handbrake_xvid" && exit
285 [[ -n "$handbrake_mp4" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing handbrake mp4 encoder, set in rip_dvd.conf to: $handbrake_mp4" && exit
286 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "xvid" ]] && [[ ! -x `which $handbrake_xvid` ]] && echo "-E- missing encoder: $handbrake_xvid" && exit
287 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "mp4" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
288 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "ip" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
289 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "hb" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
290 [[ "$encoder" == "handbrake" ]] && [[ ! -x `which ffmpeg` ]] && echo "-E- missing dependency: ffmpeg" && exit
291
292 ##############################################################################################
293
294 typeset -i ripdvd
295 if [ -z "$dvdname" ]; then
296
297   # make sure the DVD device is accessible
298   volname $dev > /dev/null 2>&1
299   if [ $? != 0 ]; then
300     echo "-E- Can't access the DVD device $dev"
301     exit 1
302   fi
303   # now capture the volume name from the device
304   dvdname=`volname $dev | awk '{ print $1 }'`
305   ripdvd=1
306
307 else 
308
309   # check to see if dvdname is a full path to a real directory
310   # if it is, set dvdname and dvdpath appropriately
311   if [ -d "$dvdname" ]; then
312     dvdpath="$dvdname"
313     dvdname=`basename "$dvdname"`
314     keep_dvdfolder=1
315     if [ -z "$dvdname" ]; then
316      echo "-E- Unable to extract dvdname from path: $dvdpath"
317      exit 1
318     fi
319     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
320       echo "-E- You must supply a full path to a valid DVD folder with this option"
321       exit 1
322     fi
323   fi
324
325   # Check to see if dvdname is a full path to a file
326   if [ -f "$dvdname" ]; then
327     valid_file=0
328
329     # check to see if dvdname is a full path to an MPG2 (VOB) file
330     # if it is, set dvdname and vobfile appropriately
331     file "$dvdname" | grep -q "MPEG"
332     if [ $? == 0 ]; then
333       # It is a valid MPEG2 file, now strip the extension off our dvdname
334       vobfile="$dvdname"
335       dvdname=`basename "$dvdname"`
336       dvdname=${dvdname%.[^.]*}
337       keep_vobfile=1
338       valid_file=1
339     fi
340
341     # check to see if dvdname is a full path to an ISO file
342     # if it is, set dvdname and isofile appropriately
343     file "$dvdname" | grep -q -e "ISO" -e "UDF"
344     if [ $? == 0 ]; then
345       # It is a valid ISO file, now strip the extension off our dvdname
346       isofile="$dvdname"
347       dvdname=`basename "$dvdname"`
348       dvdname=${dvdname%.[^.]*}
349       keep_isofile=1
350       valid_file=1
351     fi    
352
353     # check to see if dvdname is a full path to an ISO file
354     # if it is, set dvdname and isofile appropriately
355     file "$dvdname" | grep -q -e "VOB"
356     if [ $? == 0 ]; then
357       # It is a valid VOB file, now strip the extension off our dvdname
358       vobfile="$dvdname"
359       dvdname=`basename "$dvdname"`
360       dvdname=${dvdname%.[^.]*}
361       keep_vobfile=1
362       valid_file=1
363     fi    
364
365     # If we didn't find a handler for the file above, complain
366     if [ $valid_file -eq 0 ]; then
367       echo "-E- Unsupported file type: $vobfile"
368       exit 1
369     fi
370
371   # Throw an error if we can't find what the -n option is pointing to
372   else 
373     echo "-E- Unable to find the directory or file specified by the '-n $dvdname' option. Please make sure the path is valid."
374     exit 1
375   fi
376
377   # Set the ripdvd flag to false since we aren't ripping a DVD disk
378   ripdvd=0
379
380   # Since we aren't ripping a DVD disk, don't eject anything either
381   eject_disk=0
382
383 fi
384
385 # remove bad characters from the dvdname
386 dvdname=${dvdname%.} # remove trailing '.' character
387
388 # add the suffix extension to the end of the dvdname
389 dvdname=$dvdname$extension
390
391 # make a "safe" dvdname (remove special characters)
392 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
393
394 # Make sure we have a non-empty dvdname
395 if [ -z "$dvdname" ]; then
396   echo "-E- unable to determine dvdname"
397   exit 1
398 fi
399
400 # make sure our vobfile value is set
401 if [ -z "$vobfile" ]; then
402   vobfile="$dest/$dvdname.VOB"
403 fi
404
405 # set up some variables to hold various logfiles
406 logfile="$logdir/$dvdname.log"
407 passlogfile="$tmpdir/$safedvdname.log"
408 ddrescuelog=`tempfile`
409 dvdauthorlog=`tempfile`
410 encodelog=`tempfile`
411 dumplog=`tempfile`
412
413 # create the tmpdir if it doesn't already exist
414 if [ ! -d "$tmpdir" ]; then
415   mkdir -p "$tmpdir"
416   if [ $? != 0 ]; then
417     echo "-E- Unable to create the tmpdir: $tmpdir"
418     exit 1
419   fi
420 fi
421
422 # create the logdir if it doesn't already exist
423 if [ ! -d "$logdir" ]; then
424   mkdir -p "$logdir"
425   if [ $? != 0 ]; then
426     echo "-E- Unable to create the logdir: $logdir"
427     exit 1
428   fi
429 fi
430
431 ##############################################################################################
432 # cleanup functions
433 ##############################################################################################
434 cleanup() { 
435   if [ $keep_intermediate_files -eq 0 ]; then
436     [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
437     [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
438     [[ -e "$encodelog" ]] && rm -f "$encodelog"
439     [[ -e "$dumplog" ]] && rm -f "$dumplog"
440   else
441     [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
442     [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
443     [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
444     [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
445   fi
446   echo ""
447 }
448
449 fatal_and_exit() {
450   if [[ -z "$1" ]]; then
451     msg="-E- control-c killed us"
452   else
453     msg=$1
454   fi
455   echo -e 2>&1 "$msg" | tee -a "$logfile"
456   if [[ -n "$mailto" ]]; then
457     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
458   fi
459   keep_intermediate_files=1
460   exit 1
461 }
462
463 # Call our cleanup functions on INT and EXIT signals
464 trap fatal_and_exit INT
465 trap cleanup EXIT
466
467 ##############################################################################################
468 # processing functions
469 ##############################################################################################
470
471 # encode the vob file into a compressed file format using handbrake
472 function encode_vob_file_handbrake {
473   
474   # declare some globals
475   typeset handbrake_cli=""
476   typeset handbrake_video_encoder_opts=""
477   typeset filetype=""
478   typeset handbrake_audio_opts=""
479   typeset hb_profile=""
480   typeset SIZE=""
481
482   # Set a variable that we will use later to determine if we found a handler for $profile or not
483   typeset -i found_profile=0    
484
485   # For a given profile, to override the 2 pass behavior to be single pass,
486   # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
487   # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
488   PASSES="-2"
489
490   # Set our DRC option
491   DRC="-D $drc"
492
493   if [ $target_size -ne 0 ]; then
494     SIZE="-S $target_size"
495   fi 
496
497   # Check the global force_onepass_mode. If it is set, change our variables appropriately
498   # to force 1-pass encoding across all profiles.
499   if [ $force_onepass_mode -eq 1 ]; then
500     PASSES=""
501   fi
502
503   # get our audio track from the VOB file (requires mp4 version of handbrake to extract)
504   get_audio_track_from_vob "$vobfile" "$handbrake_mp4"
505
506   # XVID profile
507   if [[ "$profile" =~ "xvid" ]]; then
508     found_profile=1
509     handbrake_cli="$handbrake_xvid"
510     final_output_file="$dest/$dvdname.avi"
511     filetype="avi"
512
513     # Very High Quality (16fps)
514     if [ "$profile" == "xvidvhq" ]; then
515       handbrake_opts[0]="-f avi"
516       handbrake_opts[1]="-b $target_bitrate"
517       handbrake_opts[2]="-e xvid"
518       handbrake_opts[3]="-T"
519       handbrake_opts[4]="-5"
520       handbrake_opts[5]="-8"
521     fi
522     # High Quality (20fps)
523     if [ "$profile" == "xvidhq" ]; then
524       handbrake_opts[0]="-f avi"
525       handbrake_opts[1]="-b $target_bitrate"
526       handbrake_opts[2]="-e ffmpeg"
527       handbrake_opts[3]="-T"
528       handbrake_opts[4]="-5"
529     fi
530     # Fast (28fps)
531     if [ "$profile" == "xvid" ]; then
532       handbrake_opts[0]="-f avi"
533       handbrake_opts[1]="-b $target_bitrate"
534       handbrake_opts[2]="-e ffmpeg"
535       handbrake_opts[3]="-T"
536     fi
537   fi
538
539   # MP4 profile
540   if [[ "$profile" =~ "mp4" ]]; then
541     found_profile=1
542     handbrake_cli="$handbrake_mp4"
543     final_output_file="$dest/$dvdname.mp4"
544     PASSES=""
545
546     # Handle custom parameter overrides
547     if [ $custom_bitrate == 1 ]; then
548       handbrake_opts[0]="-b $target_bitrate"
549     fi
550     if [ $custom_audio_2ch == 0 ]; then
551       audio_2ch=0
552     fi
553     if [ $custom_audio_6ch == 0 ]; then
554       audio_6ch=0
555     fi
556
557     # Very High Quality
558     if [ "$profile" == "mp4vhq" ]; then
559       profile="hb_High_Profile"
560     fi
561     # High Quality
562     if [ "$profile" == "mp4hq" ]; then
563       profile="hb_Normal"
564     fi
565     # Fast
566     if [ "$profile" == "mp4" ]; then
567       profile="hb_Classic"
568     fi
569   fi
570
571   # iphone and ipod MP4 profiles
572   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
573     found_profile=1
574     handbrake_cli="$handbrake_mp4"
575     final_output_file="$dest/$dvdname.mp4"
576     PASSES=""
577
578     # Handle custom parameter overrides
579     if [ $custom_bitrate == 1 ]; then
580       handbrake_opts[0]="-b $target_bitrate"
581     fi
582     if [ $custom_audio_2ch == 0 ]; then
583       audio_2ch=0
584     fi
585     if [ $custom_audio_6ch == 0 ]; then
586       audio_6ch=0
587     fi
588
589     # iphone
590     if [ "$profile" == "iphone" ]; then
591       profile="hb_iPhone_&_iPod_Touch"
592     fi
593     # ipod
594     if [ "$profile" == "ipod" ]; then
595       profile="hb_iPod"
596     fi
597
598   fi
599   
600   # Predefined Handbrake Profile Handling
601   if [[ "$profile" =~ "hb" ]]; then
602     found_profile=1
603     handbrake_cli="$handbrake_mp4"
604     final_output_file="$dest/$dvdname.mp4"
605     PASSES=""
606
607     # Handle custom parameter overrides
608     if [ $custom_bitrate == 1 ]; then
609       handbrake_opts[0]="-b $target_bitrate"
610     fi
611     if [ $custom_audio_2ch == 0 ]; then
612       audio_2ch=0
613     fi
614     if [ $custom_audio_6ch == 0 ]; then
615       audio_6ch=0
616     fi
617     
618     # extract the HandBrake Profile name from $profile
619     hb_profile=`echo "$profile" | sed 's/hb_//g' | sed 's/_/ /g'`
620   fi
621
622   # Make sure we found a handler for the given profile
623   if [ $found_profile -eq 0 ]; then
624     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
625   fi
626
627   # setup our audio option
628   if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 1 ]; then
629     handbrake_audio_opts="-E faac,ac3 -6 dpl2,auto"
630   fi
631   if [ $audio_6ch -eq 1 ] && [ $audio_2ch -eq 0 ]; then
632     handbrake_audio_opts="-E ac3 -6 auto"
633   fi
634   if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 0 ]; then
635     handbrake_audio_opts="-E faac -6 dpl2"
636   fi
637   if [ -n "$track" ]; then
638     handbrake_audio_opts="$handbrake_audio_opts -a $track"
639   fi
640
641   # Convert our array of opts into a string
642   for OPTS in "${video_encoder_opts[@]}"; do 
643     handbrake_video_encoder_opts="$handbrake_video_encoder_opts:$OPTS"
644   done
645   if [ -n "$handbrake_video_encoder_opts" ]; then
646     handbrake_video_encoder_opts="-x $handbrake_video_encoder_opts"
647   fi
648   for OPTS in "${handbrake_opts[@]}"; do 
649     handbrake_cmd_line_opts="$handbrake_cmd_line_opts $OPTS"
650   done
651
652   # Append "global" command line options
653   handbrake_cmd_line_opts="$handbrake_cmd_line_opts -v 1"
654   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $PASSES"
655   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $DRC"
656   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $SCALE"
657   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $SIZE"
658
659   # Execute the handbrake command to encode the video
660   # I have to copy-n-paste the code below to handle the 2 conditions, 1) hb_profile (mp4) 2) no hb_profile (xvid)
661   # The problem is the -Z "$hb_profile" option. I have to quote the "$hb_profile" due to spaces in it, forcing me to call it out explicity.
662   if [ -n "$hb_profile" ]; then
663     echo -e "\n   Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" -Z \"$hb_profile\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1" >> "$logfile"
664     $handbrake_cli -i "$vobfile" -o "$final_output_file" -Z "$hb_profile" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1
665     handbrake_retval=$?
666   else 
667     echo -e "\n   Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1" >> "$logfile"
668     $handbrake_cli -i "$vobfile" -o "$final_output_file" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1
669     handbrake_retval=$?
670   fi
671   if [ $handbrake_retval != 0 ]; then
672     fatal_and_exit "-E- Unhandled handbrake error"
673   fi
674
675   # Concatenate the encode log to our main log file, greping out unwanted lines
676   cat $encodelog | grep -v "Encoding:" | grep -v "hb_demux_ps" >> "$logfile" 
677   cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | head -1 >> "$logfile"
678   cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | tail -1 >> "$logfile"
679 }
680
681 # encode the vob file into a compressed file format using mencoder
682 function encode_vob_file_mencoder {
683
684   # Set a variable that we will use later to determine if we found a handler for $profile or not
685   typeset -i found_profile=0
686
687   # For a given profile, to override the 2 pass behavior to be single pass,
688   # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
689   # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
690   PASSES="1 2"
691
692   # Declare our default 2 pass variables
693   passlogfile_opt="-passlogfile $passlogfile"
694   pass_opt="pass=%PASS"
695
696   # Check the global force_onepass_mode. If it is set, change our variables appropriately
697   # to force 1-pass encoding across all profiles.
698   if [ $force_onepass_mode -eq 1 ]; then
699     PASSES="2"
700     passlogfile_opt=""
701     pass_opt=""    
702   fi
703
704   # XVID profile
705   if [[ "$profile" =~ "xvid" ]]; then
706     found_profile=1
707     final_output_file="$dest/$dvdname.avi"
708     mencoder_general_opts="$lang_opts $passlogfile_opt"
709     mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
710     mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
711     mencoder_video_encoder_opts="-ovc xvid -xvidencopts $pass_opt"
712
713     # Very High Quality (16fps)
714     if [ "$profile" == "xvidvhq" ]; then
715       video_encoder_opts[0]="bitrate=$target_bitrate"
716       video_encoder_opts[1]="threads=$mencoder_threads"
717       video_encoder_opts[2]="chroma_opt"
718       video_encoder_opts[3]="vhq=4"
719       video_encoder_opts[4]="bvhq=1"
720       video_encoder_opts[5]="quant_type=mpeg"
721       video_encoder_opts[6]="autoaspect"
722     fi
723     # High Quality (20fps)
724     if [ "$profile" == "xvidhq" ]; then
725       video_encoder_opts[0]="bitrate=$target_bitrate"
726       video_encoder_opts[1]="threads=$mencoder_threads"
727       video_encoder_opts[2]="chroma_opt"
728       video_encoder_opts[3]="vhq=2"
729       video_encoder_opts[4]="bvhq=1"
730       video_encoder_opts[5]="quant_type=mpeg"
731       video_encoder_opts[6]="autoaspect"
732     fi
733     # Fast (28fps)
734     if [ "$profile" == "xvid" ]; then
735       video_encoder_opts[0]="bitrate=$target_bitrate"
736       video_encoder_opts[1]="threads=$mencoder_threads"
737       video_encoder_opts[2]="vhq=0"
738       video_encoder_opts[3]="turbo"
739       video_encoder_opts[4]="autoaspect"
740     fi
741
742     for OPTS in "${video_encoder_opts[@]}"; do 
743       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
744     done
745
746     if [ $audio_2ch -eq 0 ]; then
747       # These options produce good 6 channel audio for linux and windows
748       mencoder_audio_opts="-oac copy"
749       # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
750       mencoder_audioch_opts[0]="-channels 6 -af channels=6"
751       mencoder_audioch_opts[1]="-af channels=6"
752       mencoder_audioch_opts[2]=""
753     else
754       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
755       mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
756       mencoder_audioch_opts[0]=""
757     fi
758  
759   fi
760
761   # iphone and ipod MP4 profiles
762   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
763     found_profile=1
764     if [ "$profile" == "iphone" ]; then
765       # SCALE: 480x320
766       # scale width to 480, set height appropriately, but keep a multiple of 16
767       #SCALE=",scale=480:-10"
768       # scale the video down however far is necessary to fit in 480x320
769       SCALE=",dsize=480:320:0,scale=-8:-8"
770     else
771       # SCALE: 320x240
772       # scale width to 320, set height appropriately, but keep a multiple of 16
773       #SCALE=",scale=320:-10"
774       # scale the video down however far is necessary to fit in 320x240
775       SCALE=",dsize=320:240:0,scale=-8:-8"
776     fi
777     final_output_file="$dest/$dvdname.mp4"
778     mencoder_general_opts="$lang_opts $passlogfile_opt"
779     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
780     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
781     mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
782     video_encoder_opts[0]="bitrate=$target_bitrate"
783     video_encoder_opts[1]="threads=$mencoder_threads"
784     video_encoder_opts[2]="vbv_maxrate=1500"
785     video_encoder_opts[3]="vbv_bufsize=2000"
786     video_encoder_opts[4]="nocabac"
787     video_encoder_opts[5]="me=umh"
788     video_encoder_opts[6]="subq=6"
789     video_encoder_opts[7]="frameref=6"
790     video_encoder_opts[8]="trellis=1"
791     video_encoder_opts[9]="level_idc=30"
792     video_encoder_opts[10]="global_header"
793     video_encoder_opts[11]="bframes=0"
794     video_encoder_opts[12]="partitions=all"
795     for OPTS in "${video_encoder_opts[@]}"; do 
796       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
797     done
798
799     mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
800     mencoder_audioch_opts[0]="-channels 2 -srate 48000"
801   fi
802
803   if [ $found_profile -eq 0 ]; then
804     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
805   fi
806
807   # Do not edit this line. $mencoder_video_encoder_opts must be last
808   mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
809   mencoder_retval=0
810
811   for PASS in $PASSES
812   do 
813     # Set some options based on which pass we are in
814     mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
815     [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
816     [ $PASS -eq 1 ] && output_file="/dev/null"
817     [ $PASS -eq 2 ] && output_file="$final_output_file"
818   
819     # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
820     for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
821     do
822       echo -e "   Encoding pass $PASS"
823       echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
824       mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
825       mencoder_retval=$? 
826       grep -q "\[channels\] Invalid" $encodelog
827       if [ $? != 0 ]; then          
828         break;
829       else
830         echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
831       fi
832     done
833       
834     if [ $mencoder_retval != 0 ]; then
835       fatal_and_exit "-E- Unhandled mencoder error"
836     fi
837
838     # Concatenate the encode log to our main log file, greping out unwanted lines
839     cat $encodelog | grep -v "^Pos:" | grep -v "duplicate" >> "$logfile"
840
841   done
842 }
843
844 function make_dvd_iso_image {
845
846   isofile="$1"
847
848   # check to see if we have a dvdpath to rip from instead of $dev
849   if [ -z "$dvdpath" ]; then
850     # load the CSS codes in the DVD drive 
851     lsdvd $dev >> "$logfile"
852     if [ $? != 0 ]; then
853       fatal_and_exit "-E- lsdvd $dev failed" 
854     fi
855
856     # read the DVD, ignoring/skipping CRC errors
857     ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
858     if [ $? != 0 ]; then
859       fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
860     fi
861     cat "$ddrescuelog" >> "$logfile"
862   else
863     # rip from a path instead
864     make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
865   fi
866 }
867
868 function make_dvd_iso_image_from_folder {
869   
870   src="$1"
871   dst="$2"
872   handle_error=$3
873   
874   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
875
876   # make an iso image out of our directory
877   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
878   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
879
880   # set the audio languages from the iso if it exists and is non-zero in size
881   if [ -s "$dst" ]; then
882     get_feature_title "$dst"
883     get_audio_id_from_iso "$dst"
884   fi
885
886   # make sure we were able to create the iso image from the folder given to us
887   if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
888     echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
889     echo "   Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
890     # remove the bad iso file
891     [[ -e "$dst" ]] && rm -f "$dst"
892     # get the feature title from the DVD folder
893     get_feature_title "$dvdpath"
894     # create our main VOB file from the ISO
895     create_main_vob_with_mplayer "$dvdpath" 
896     # get our audio id from the VOB file
897     get_audio_id_from_vob "$vobfile"
898   fi
899 }
900
901 function make_dvdbackup_folder_image {
902   # extract the feature title from the DVD image
903   echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
904   [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
905   dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
906   if [ $? != 0 ]; then
907     fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
908   fi
909 }
910
911 function make_dvdauthor_folder_image {
912   # create a new DVD video of the feature title
913   echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
914   [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
915   dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
916   cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
917
918   # There is a chance that dvdauthor won't like some of the VOBs.
919   # We can't tell ahead of time which ones it will choke on. 
920   # So, we need to run it over and over again until it can process
921   # all the VOBs. If it can't handle one of them, run it through
922   # mencoder to fix it and try again. These errors are typically
923   # present due to the copy protection that ddrescue removed.
924   grep -q "SCR moves" $dvdauthorlog
925   while [ $? == 0 ]; do
926     # fix bad vobs that get the "SCR moves backwards" error:
927     #  STAT: Processing VTS_01_0.VOB...
928     #  ERR:  SCR moves backwards, remultiplex input.
929     badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
930     if [[ ! -f "$badvob" ]]; then
931       fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
932     fi
933     echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
934     cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
935     mv -f $badvob.fixed $badvob
936     echo "-> Creating DVD video $dest/$dvdname"
937     dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
938     cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
939     grep -q "SCR moves" $dvdauthorlog
940   done
941 }
942
943 function get_feature_title {
944   source="$1"
945   # if a feature title was given on the command line, use it
946   if [ $feature_title_override -ne 0 ]; then
947     feature_title=$feature_title_override
948     return 0
949   fi
950   # otherwise, use lsdvd to figure it out
951   if [ $ripdvd -eq 1 ]; then
952     feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
953   else 
954     feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
955   fi
956 }
957
958 function create_main_vob_with_cat {
959   # cd to the feature title DVD folder
960   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
961   if [ $? != 0 ]; then
962     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
963   fi
964
965   # concatenate all the VOBs together into 1 giant VOB
966   vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
967   cat $vobs > "$tmpdir/$dvdname.VOB"
968
969   # cd back to the dir we started from
970   popd > /dev/null 2>&1
971 }
972
973 function create_main_vob_with_mplayer {
974
975   # argument processing  
976   source="$1"
977   remove_dumplog=$2
978
979   # make sure we have a valid feature title
980   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
981     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
982   fi
983
984   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
985   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
986     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
987     msg="$msg We also detected another condition that requires us to use dumpstream. "
988     msg="$msg\n    Unable to rip this DVD in the mode you requested."
989     fatal_and_exit "$msg"
990   fi
991
992   # use mplayer to create the main VOB file
993   echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
994   echo "   mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
995   mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
996   if [ $? != 0 ]; then
997     cat $dumplog | grep -v "^A:" >> "$logfile"
998     fatal_and_exit "-E- Mplayer Failed"
999   fi
1000   cat $dumplog | grep -v "^A:" >> "$logfile"
1001   [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
1002 }
1003
1004 function get_audio_id_from_iso {
1005   # Adjust our audio ID to find the english audio stream
1006   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
1007   iso="$1"
1008   aidcheck=`tempfile`
1009   aid=$default_aid
1010   alang=$default_alang
1011   if [ $aid_override -lt 0 ]; then 
1012     mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
1013     grep -q "aid: $aid" $aidcheck
1014     while [ $? == 1 ] && [ $aid -lt 159 ]; do
1015       (( aid = aid + 1 ))
1016       grep -q "aid: $aid" $aidcheck
1017     done
1018     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1019   else
1020     aid=$aid_override
1021   fi
1022   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
1023   # mencoder default DVD audio track language selection (english)
1024   lang_opts="-aid $aid -alang $alang"
1025 }
1026
1027 function get_crop_from_iso { 
1028   FRAMES=10000
1029   echo "-> Detecting black frame border crop value from ISO file"
1030   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
1031   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
1032   [[ -e "md5sums" ]] && rm -f "md5sums"
1033   CROP=`cat $dumplog | grep CROP | tail -1`
1034   echo "   Found crop value of $CROP" >> "$logfile"
1035   CROP=${CROP#* crop=}
1036   CROP=${CROP%%\).*}
1037   typeset -i CROPCHECK
1038   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
1039   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
1040   if [ -z "$CROP" ]; then
1041     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
1042     return
1043   fi
1044   if [ $CROPCHECK -lt 0 ]; then 
1045     CROP=""
1046   else 
1047     CROP=",crop=$CROP"
1048   fi
1049   echo "   Setting mencoder crop filter to: $CROP"
1050 }
1051
1052 function get_crop_from_vob { 
1053   FRAMES=10000
1054   echo "-> Detecting black frame border crop value from VOB file"
1055   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark \"$vobfile\" > $dumplog 2>&1" >> "$logfile"
1056   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark "$vobfile" > $dumplog 2>&1
1057   [[ -e "md5sums" ]] && rm -f "md5sums"
1058   CROP=`cat $dumplog | grep CROP | tail -1`
1059   echo "   Found crop value of $CROP" >> "$logfile"
1060   CROP=${CROP#* crop=}
1061   CROP=${CROP%%\).*}
1062   typeset -i CROPCHECK
1063   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
1064   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
1065   if [ -z "$CROP" ]; then
1066     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
1067     return
1068   fi
1069   if [ $CROPCHECK -lt 0 ]; then 
1070     CROP=""
1071   else 
1072     CROP=",crop=$CROP"
1073   fi
1074   echo "   Setting mencoder crop filter to: $CROP"
1075 }
1076
1077 function get_audio_track_from_vob {
1078   # Adjust our audio ID to find the english audio stream
1079   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
1080   vob="$1"
1081   handbrake_cli="$2"
1082   aidcheck=`tempfile`
1083   aid=$default_aid
1084   alang=$default_alang
1085   if [ $aid_override -lt 0 ]; then 
1086     mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
1087     grep -q "Found audio stream: $aid" $aidcheck
1088     while [ $? == 1 ] && [ $aid -lt 159 ]; do
1089       (( aid = aid + 1 ))
1090       grep -q "Found audio stream: $aid" $aidcheck
1091     done
1092     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1093   else 
1094     aid=$aid_override
1095   fi
1096   # Now that we've found the right audio id, find the corresponding audio track in HandBrake
1097
1098   # convert the aid we found into hex
1099   aid_hex=`echo "obase=16; $aid" | bc`
1100   
1101   # extract the audio streams in the vob
1102   #ffmpeg -i "$vob" > $aidcheck 2>&1
1103   $handbrake_cli --stop-at 0 -i "$vob" -o /dev/null -v 100 > $aidcheck 2>&1
1104   
1105   # find the stream that matches our aid
1106   #stream=`grep "Stream.*\[0x$aid_hex\]" $aidcheck`
1107   #stream=`grep "scan: audio" $aidcheck | grep -n "" | grep "scan: audio 0x$aid_hex"`
1108   stream=`grep "add_audio_to_title:" $aidcheck | grep -n "" | grep "add_audio_to_title:.* stream 0x$aid_hex"`
1109  
1110   # extract the track number that handbrake uses
1111   #track=`expr match "$stream" '.*#[0-9]\.\([0-9]*\)'`
1112   track=`expr match "$stream" '^\([0-9]*\):'`
1113
1114   if [ -n "$track" ]; then   
1115     echo "   Setting the audio ID to $aid. Setting the audio track to $track." | tee -a "$logfile"
1116   fi
1117 }
1118
1119 function get_audio_id_from_vob {
1120   # Adjust our audio ID to find the english audio stream
1121   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
1122   vob="$1"
1123   aidcheck=`tempfile`
1124   aid=$default_aid
1125   alang=$default_alang
1126   if [ $aid_override -lt 0 ]; then 
1127     mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
1128     grep -q "Found audio stream: $aid" $aidcheck
1129     while [ $? == 1 ] && [ $aid -lt 159 ]; do
1130       (( aid = aid + 1 ))
1131       grep -q "Found audio stream: $aid" $aidcheck
1132     done
1133     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1134   else 
1135     aid=$aid_override
1136   fi
1137   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
1138   # mencoder default DVD audio track language selection (english)
1139   lang_opts="-aid $aid -alang $alang"
1140 }
1141
1142 function check_vob_for_corrupted_start {
1143   # check to see if the beginning of the DVD has a form of copy protection
1144   # where they have deliberately broken the first X number of frames of the DVD.
1145   # If we don't skip these, our resulting VOB file will not play.
1146   badvobcheck=`tempfile`
1147   endpos=360
1148   skip=0
1149   mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
1150   if [ $? != 0 ]; then
1151     fatal_and_exit "-E- Mencoder Failed"
1152   fi
1153   grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
1154   while [ $? == 0 ] && [ $skip -lt $endpos ]; do
1155     (( skip = skip + 5 ))
1156     echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
1157     mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
1158     if [ $? != 0 ]; then
1159       fatal_and_exit "-E- Mencoder Failed"
1160     fi
1161     grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
1162   done
1163   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
1164
1165   # cat the giant VOB into mencoder to create a playable VOB file
1166   cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
1167   if [ $? != 0 ]; then
1168     fatal_and_exit "-E- Mencoder Failed"
1169   fi
1170 }
1171
1172 function check_vob_for_completeness {
1173   # check to make sure we got out a complete VOB.
1174   # there is another kind of copy protection where the VOB's may
1175   # have "MPG EOF" frames in the middle of the stream. 
1176   # this causes mencoder to not process the entire VOB, and exit without any errors.
1177   # detect this by seeing how much smaller the dst vob is from the src vob.
1178   MAX_FILESIZE_DELTA_PERCENT=70
1179   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
1180   DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
1181   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
1182   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
1183     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
1184     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
1185     create_main_vob_with_mplayer "$isofile"
1186     [[ -e "$dumplog" ]] && rm -f $dumplog
1187     DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
1188     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
1189     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
1190       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
1191     fi
1192   fi
1193 }
1194
1195 function check_vob_for_too_many_video_packets {
1196   # If our earlier algorithm to work around this failed, throw an error.
1197   # check to see if this DVD has a protection scheme we don't know how to work around
1198   # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
1199   # for some reason, the video is black, while the audio rolls, then the video finally comes
1200   # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of 
1201   # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
1202   # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
1203   grep -q "Too many video packets in the buffer:" "$logfile"
1204   if [ $? == 0 ]; then
1205     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
1206     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
1207     create_main_vob_with_mplayer "$isofile"
1208     grep -q "Too many video packets in the buffer:" $dumplog
1209     if [ $? == 0 ]; then
1210       [[ -e "$dumplog" ]] && rm -f $dumplog
1211       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
1212     fi
1213     [[ -e "$dumplog" ]] && rm -f $dumplog
1214   fi
1215 }
1216
1217 function check_vob_for_a52_crc_errors {
1218   # Let's see if we can playback our newly created VOB file without any errors.
1219   # if there are issues, let's detect them now, and try to recreate the VOB
1220   # there are some forms of copy protection that have missed above, that evidence
1221   # themselves when we try to playback the VOB file. This was added to deal with
1222   # the "a52: CRC check failed" copy protection scheme.
1223   MAX_ERRORS=10
1224   ENDPOS=120
1225   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
1226   mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
1227   cat $dumplog | grep -v "^A:" >> "$logfile"
1228   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
1229   if [ $errors -gt $MAX_ERRORS ]; then
1230     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
1231     create_main_vob_with_mplayer "$isofile"
1232     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
1233     mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
1234     if [ $? != 0 ]; then
1235       cat $dumplog | grep -v "^A:" >> "$logfile"
1236       fatal_and_exit "-E- Mplayer Failed"
1237     fi
1238     cat $dumplog | grep -v "^A:" >> "$logfile"
1239     errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
1240     if [ $errors -gt $MAX_ERRORS ]; then
1241       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
1242     fi
1243   fi
1244   [[ -e "$dumplog" ]] && rm -f $dumplog
1245 }
1246
1247 function calculate_bitrate_from_target_size {
1248   # determine what our bitrate needs to be if a target size was specified instead
1249   if [ $target_size -ne 0 ]; then
1250     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
1251     ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
1252     custom_bitrate=1
1253     echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
1254   fi
1255 }
1256
1257 function create_dvdauthor_dvd_xml_file {
1258   # make a dvdauthor xml menu file to create a valid DVD video from 
1259   # this script does a good job, but we'll still need to clean it up a bit after it runs
1260   echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
1261   makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
1262   if [ $? != 0 ]; then
1263     fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
1264   fi
1265
1266   # replace the first line of the xml file to remove the bad dest path
1267   awk -v line=1 -v new_content="<dvdauthor>" '{
1268     if (NR == line) {
1269       print new_content;
1270     } else {
1271       print $0;
1272     }
1273   }' dvd.xml > dvd.xml.new
1274   mv -f dvd.xml.new dvd.xml
1275   if [ $? != 0 ]; then
1276     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1277   fi
1278
1279   # remove the "<video " property line from the xml file
1280   cat dvd.xml | grep -v "<video" > dvd.xml.new
1281   mv -f dvd.xml.new dvd.xml
1282   if [ $? != 0 ]; then
1283     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1284   fi
1285   
1286   # remove the extra <pgc>..</pgc> pairs
1287   cat dvd.xml | awk 'BEGIN {x=1}
1288   {
1289     if ($0~"</pgc>") {x=0}
1290     if (x==1) {print $0}
1291     if ($0~"<pgc>") {x=1}
1292   }' > dvd.xml.new
1293   echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
1294   mv -f dvd.xml.new dvd.xml
1295   if [ $? != 0 ]; then
1296     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1297   fi
1298
1299   # remove the VTS_*_0.VOB file as this is just the main menu video clip
1300   cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
1301   mv -f dvd.xml.new dvd.xml
1302   if [ $? != 0 ]; then
1303     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1304   fi
1305 }
1306
1307 function check_for_mplayer_dumpstream_incompatibility {
1308
1309   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
1310
1311   if [ ! -e "$vobfile" ]; then
1312     # mplayer dumpstream does not work on DVDs that obscure the feature title.
1313     # A DVD that has 99 titles, where the longest title isn't the main feature
1314     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
1315     # out what the feature title is. This script will run through that flow if we
1316     # set use_mplayer_dumpstream to 0. Check for this here.
1317     if [ $ripdvd -eq 1 ]; then
1318       lsdvd $dev | grep -q "Title: 99"
1319     else
1320       lsdvd "$isofile" | grep -q "Title: 99"
1321     fi
1322     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
1323     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
1324       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
1325         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
1326         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1327         echo "    You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
1328         invalid_feature_title=1
1329       else 
1330         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
1331         echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
1332         echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1333         use_mplayer_dumpstream=0
1334         invalid_feature_title=1
1335       fi
1336       return
1337     fi
1338   fi
1339
1340   # There is another form of protection that causes the mplayer dumpstream to fail. 
1341   # This can be detected by telling mplayer to parse the VOB file by copying its audio
1342   # video streams to a dummy output file (/dev/null). Do that here to check for that 
1343   # problem before continuing.
1344   if [ -e "$vobfile" ]; then
1345     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
1346     mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
1347     grep -q "Too many audio packets in the buffer" $dumplog
1348     if [ $? == 0 ]; then
1349       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
1350       use_mplayer_dumpstream=0
1351       mplayer_dumpstream_incompatibility=1
1352     fi
1353     [[ -e "$dumplog" ]] && rm -f $dumplog
1354   fi
1355 }
1356
1357 function fill_mythvideo_metadata {
1358
1359   # This function must be passed the filename as an argument
1360   # The filename must be a full path to the file
1361   filename="$1"
1362
1363   # Make sure the fill mythvideo metadata option has been set to 1
1364   if [ $fill_mythvideo_metadata -eq 0 ]; then
1365     echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
1366     return 0
1367   fi
1368
1369   # If the fill mythvideo metadata script is present, run it
1370   # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
1371   if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
1372     echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
1373     fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
1374   else
1375     echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
1376     echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
1377   fi
1378 }
1379
1380 # remove the intermediate VOB file
1381 function remove_intermediate_vob_file {
1382   if [ $keep_intermediate_files -eq 0 ]; then
1383     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
1384   else
1385     echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
1386   fi
1387 }
1388
1389 # remove the original DVD image 
1390 function remove_intermediate_iso_file {
1391   [[ $keep_isofile -eq 1 ]] && return 1
1392   if [ $keep_intermediate_files -eq 0 ]; then
1393     [[ -e "$isofile" ]] && rm "$isofile"
1394   else
1395     echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
1396   fi
1397 }
1398
1399 # remove the intermediate dvdbackup folder
1400 function remove_intermediate_dvdbackup_folder {
1401   if [ $keep_intermediate_files -eq 0 ]; then
1402     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
1403   else
1404     echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
1405   fi
1406 }
1407
1408 ##############################################################################################
1409 # MAIN
1410 ##############################################################################################
1411
1412 # Make a note of when this DVD rip started
1413 date=`date`
1414 echo -e "\n$date DVD rip started" >> "$logfile"
1415 echo "$cmd" >> "$logfile"
1416
1417 # Rip the DVD - Mirror Mode
1418 if [ $mirror_mode -eq 1 ]; then
1419   echo "-> Ripping DVD $dvdname to $dest"
1420
1421   # use ddrescue to make an ISO image of the disk
1422   make_dvd_iso_image "$dest/$dvdname.iso"
1423
1424   # add this video data to the mythtv DB
1425   fill_mythvideo_metadata "$dest/$dvdname.iso" 
1426
1427   # eject the disk upon completion
1428   if [ $eject_disk -ne 0 ]; then
1429     eject -T $dev
1430   fi
1431
1432   date=`date`
1433   echo "$date DVD rip completed" | tee -a "$logfile"
1434
1435   if [[ -n "$mailto" ]]; then
1436     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1437   fi
1438
1439 fi
1440
1441 # Rip the DVD - Main Title Feature Only
1442 if [ $mirror_mode -eq 0 ]; then
1443
1444   # Rip image from DVD
1445   if [ $ripdvd -eq 1 ]; then
1446     echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
1447     # use ddrescue to make an ISO image of the disk
1448     make_dvd_iso_image "$tmpdir/$dvdname.iso"
1449   fi
1450
1451   # Rip image from DVD path
1452   if [ -n "$dvdpath" ]; then
1453     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
1454     make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
1455   fi
1456
1457   # make sure our isofile value is set
1458   if [ -z "$isofile" ]; then
1459     isofile="$tmpdir/$dvdname.iso"
1460   fi
1461      
1462   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
1463
1464     if [ ! -e "$vobfile" ]; then
1465       echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
1466       
1467       # get the feature title from the ISO
1468       get_feature_title "$isofile"
1469  
1470       # get the crop value from the ISO
1471       get_crop_from_iso
1472
1473       # check for mplayer dumpstream incompatibilities
1474       # if they exist, this method will set this mode to 0.
1475       check_for_mplayer_dumpstream_incompatibility
1476
1477       if [ $use_mplayer_dumpstream -eq 1 ]; then 
1478
1479         # get our audio id from the ISO file
1480         get_audio_id_from_iso "$isofile"
1481
1482         # create our main VOB file from the ISO
1483         create_main_vob_with_mplayer "$isofile"
1484      
1485         # remove the intermediate VOB file
1486         remove_intermediate_vob_file
1487
1488         # it's possible that our VOB is still corrupted in some manner
1489         # check to make sure it is still a good VOB before continuing.
1490         check_for_mplayer_dumpstream_incompatibility
1491
1492       fi
1493  
1494       if [ $use_mplayer_dumpstream -eq 0 ]; then 
1495
1496         # use dvdbackup to make a DVD folder of the feature title
1497         make_dvdbackup_folder_image
1498   
1499         # create our main VOB file
1500         create_main_vob_with_cat
1501
1502         # get our audio id from the VOB file
1503         get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
1504   
1505         # check for corrupted VOB start
1506         check_vob_for_corrupted_start
1507  
1508         # check to make sure our VOB is complete
1509         check_vob_for_completeness
1510
1511         # check to make sure our VOB doesn't have too many video packets
1512         check_vob_for_too_many_video_packets
1513
1514         # check to make sure our VOB doesn't have a52 crc errors
1515         check_vob_for_a52_crc_errors
1516
1517         # remove the intermediate VOB file
1518         remove_intermediate_vob_file
1519
1520       fi
1521
1522       # remove the intermediate ISO file
1523       remove_intermediate_iso_file
1524
1525     else
1526       if [ "$encoder" != "handbrake" ]; then 
1527         echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
1528         # get our audio id from the VOB file
1529         get_audio_id_from_vob "$vobfile"
1530         # get the crop value from the VOB
1531         get_crop_from_vob
1532       fi
1533     fi
1534
1535     # eject the DVD disk since we are finished with it
1536     [ $eject_disk -eq 2 ] && eject -T $dev
1537
1538     # encode the VOB file to a compressed file format
1539     if [ $make_final_dest_comp -eq 1 ]; then
1540       echo "-> Encoding the DVD video to a compressed file using $encoder" | tee -a "$logfile"
1541
1542       # determine what our bitrate needs to be if a target size was specified instead
1543       calculate_bitrate_from_target_size        
1544      
1545       # encode the vob file into a compressed file format
1546       if [[ "$encoder" == "mencoder" ]]; then 
1547         encode_vob_file_mencoder
1548       fi
1549       if [[ "$encoder" == "handbrake" ]]; then
1550         encode_vob_file_handbrake
1551       fi
1552
1553       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
1554         [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";
1555         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
1556       else
1557         echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
1558         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
1559       fi
1560     fi
1561
1562   # add this video data to the mythtv DB
1563   [ $make_final_dest_comp -eq 1 ] && fill_mythvideo_metadata "$final_output_file" 
1564   [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile" 
1565     
1566   else
1567
1568   # use dvdbackup to make a DVD folder of the feature title
1569   make_dvdbackup_folder_image
1570
1571   # cd to the feature title DVD folder
1572   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1573   if [ $? != 0 ]; then
1574     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1575   fi
1576   
1577   # create the dvd.xml file for dvdauthor
1578   create_dvdauthor_dvd_xml_file  
1579
1580   # make the final DVD folder image
1581   make_dvdauthor_folder_image
1582
1583   # add this video data to the mythtv DB
1584   fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS" 
1585  
1586   # cd back to the dir we started from
1587   popd > /dev/null 2>&1
1588
1589   if [ $make_final_dest_iso -eq 1 ]; then
1590
1591     # make an iso image out of our directory
1592     make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1593    
1594     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
1595     if [ -s "$dest/$dvdname.iso" ]; then
1596       if [ $make_final_dest_folder -eq 0 ]; then
1597         echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1598         # remove the folder of the DVD image now that we have a .iso version of it
1599         [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1600       fi
1601     else
1602       # we created an empty iso file, remove it
1603       echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1604       echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1605       [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1606     fi
1607  
1608     # add this video data to the mythtv DB
1609     fill_mythvideo_metadata "$dest/$dvdname.iso" 
1610
1611   fi
1612
1613   fi
1614
1615   # remove the ddrescue DVD ISO image
1616   remove_intermediate_iso_file
1617
1618   # remove the tmp dvdbackup folder of the DVD image
1619   remove_intermediate_dvdbackup_folder
1620
1621   # eject the DVD disk upon completion
1622   [ $eject_disk -eq 1 ] && eject -T $dev
1623
1624   date=`date`
1625   echo "$date DVD rip completed" | tee -a "$logfile"
1626
1627   if [[ -n "$mailto" ]]; then
1628     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1629   fi
1630
1631 fi
1632
1633 ##############################################################################################